unit Exdiale0;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, AdDial, AdModem, AdPort, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    ApdComPort1: TApdComPort;
    ApdModem1: TApdModem;
    ApdModemDialer1: TApdModemDialer;
    procedure FormCreate(Sender: TObject);
    procedure ApdModemDialer1Busy(Sender: TObject);
    procedure ApdModemDialer1Connect(Sender: TObject);
    procedure ApdModemDialer1ConnectionEstablished(Sender: TObject);
    procedure ApdModemDialer1CycleDial(Sender: TObject);
    procedure ApdModemDialer1DialCount(M: TObject; Remaining: Word);
    procedure ApdModemDialer1DialStart(Sender: TObject);
    procedure ApdModemDialer1Error(Sender: TObject);
    procedure ApdModemDialer1GotLineSpeed(M: TObject; Speed: Longint);
    procedure ApdModemDialer1NoCarrier(Sender: TObject);
    procedure ApdModemDialer1NoDialTone(Sender: TObject);
    procedure ApdModemDialer1RetryCount(M: TObject; Remaining: Word);
    procedure ApdModemDialer1RetryEnd(Sender: TObject);
    procedure ApdModemDialer1RetryStart(Sender: TObject);
    procedure ApdModemDialer1TooManyTries(Sender: TObject);
    procedure ApdModemDialer1Voice(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddStatusLine(const Msg : String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AddStatusLine(const Msg : String);
begin
  Listbox1.Items.Add(Msg);
  Listbox1.ItemIndex := Pred(Listbox1.Items.Count);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ApdComPort1.Open  := True;
  ApdModem1.Started := True;
end;

procedure TForm1.ApdModemDialer1Busy(Sender: TObject);
begin
  AddStatusLine('Remote is busy');
end;

procedure TForm1.ApdModemDialer1Connect(Sender: TObject);
begin
  AddStatusLine('Modem connected!');
end;

procedure TForm1.ApdModemDialer1ConnectionEstablished(Sender: TObject);
begin
  AddStatusLine('Connection established!');
end;

procedure TForm1.ApdModemDialer1CycleDial(Sender: TObject);
begin
  if ApdModemDialer1.Retrying then
    AddStatusLine('Cancelling retry...')
  else
    AddStatusLine('Cycling dial attempt...');
end;

procedure TForm1.ApdModemDialer1DialCount(M: TObject; Remaining: Word);
begin
  AddStatusLine('Dialing. ' + IntToStr(Remaining) + ' seconds to go');
end;

procedure TForm1.ApdModemDialer1DialStart(Sender: TObject);
begin
  AddStatusLine('Starting a new dial attempt');
end;

procedure TForm1.ApdModemDialer1Error(Sender: TObject);
begin
  AddStatusLine('Modem returned ERROR result');
end;

procedure TForm1.ApdModemDialer1GotLineSpeed(M: TObject; Speed: Longint);
begin
  AddStatusLine('Connected at ' + IntToStr(Speed) + ' baud');
end;

procedure TForm1.ApdModemDialer1NoCarrier(Sender: TObject);
begin
  AddStatusLine('Modem returned NO CARRIER');
end;

procedure TForm1.ApdModemDialer1NoDialTone(Sender: TObject);
begin
  AddStatusLine('Modem returned NO DIALTONE');
end;

procedure TForm1.ApdModemDialer1RetryCount(M: TObject; Remaining: Word);
begin
  AddStatusLine(IntToStr(Remaining) + ' seconds before new dial attempt');
end;

procedure TForm1.ApdModemDialer1RetryEnd(Sender: TObject);
begin
  AddStatusLine('Retry finished.  Will attempt to dial again.');
end;

procedure TForm1.ApdModemDialer1RetryStart(Sender: TObject);
begin
  AddStatusLine('Dial failed.  Will wait before retrying...');
end;

procedure TForm1.ApdModemDialer1TooManyTries(Sender: TObject);
begin
  AddStatusLine('Too many failed dial attempts. Giving up.');
end;

procedure TForm1.ApdModemDialer1Voice(Sender: TObject);
begin
  AddStatusLine('Remote answered with voice');
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if (Edit1.Text <> '') then begin
    ApdModemDialer1.PhoneNumber := Edit1.Text;
    ApdModemDialer1.Dial;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ApdModemDialer1.Dialing then begin
    ApdModemDialer1.Abort;
    CanClose := True;
  end;
end;
end.

