unit Exflist0;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, AdProtcl, AdPStat, AdTerm, AdPort, StdCtrls;

type
  TExampleFList = class(TForm)
    ApdComPort1: TApdComPort;
    ApdTerminal1: TApdTerminal;
    ApdProtocol1: TApdProtocol;
    ApdProtocolStatus1: TApdProtocolStatus;
    ApdProtocolLog1: TApdProtocolLog;
    AddFiles: TButton;
    procedure ApdTerminal1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ApdProtocol1ProtocolError(CP: TObject; ErrorCode: Integer);
    procedure AddFilesClick(Sender: TObject);
    procedure ApdProtocol1ProtocolNextFile(CP: TObject;
      var FName: OpenString);
  private
    { Private declarations }
    FileList : TStringList;
    FileIndex : Word;
  public
    { Public declarations }
    constructor Create(AComponent : TComponent); override;
  end;

var
  ExampleFList: TExampleFList;

implementation

{$R *.DFM}

constructor TExampleFList.Create(AComponent : TComponent);
begin
  inherited Create(AComponent);
  FileList := TStringList.Create;
end;

procedure TExampleFList.ApdTerminal1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_PRIOR then
    ApdProtocol1.StartTransmit
  else if Key = VK_NEXT then
    ApdProtocol1.StartReceive;
end;

procedure TExampleFList.ApdProtocol1ProtocolError(CP: TObject;
  ErrorCode: Integer);
begin
  ShowMessage('Fatal protocol error: ' + ErrorMsg(ErrorCode));
end;

procedure TExampleFList.AddFilesClick(Sender: TObject);
begin
  FileList.Add('EXFLIST.DPR');
  FileList.Add('EXFLIST0.PAS');
  FileList.Add('EXFLIST0.DFM');
  FileIndex := 0;

  ApdTerminal1.StuffString('Files added!');
  ApdTerminal1.ForcePaint;
  ApdTerminal1.SetFocus;
end;

procedure TExampleFList.ApdProtocol1ProtocolNextFile(CP: TObject;
  var FName: OpenString);
begin
  try
    FName := FileList[FileIndex];
    Inc(FileIndex);
  except
    FName := '';
  end;
end;

end.
